#include "e_mod_main.h"
#ifdef HAVE_AMAROK
#include <Ecore.h>

void amarok_init(void *data){
  Eloquence_Face *face = data;

  snprintf(face->amarok_temp_isPlaying, 
		  sizeof(face->amarok_temp_isPlaying),"%s", 
		  "/tmp/eloquence_amarok_isPlaying.tmp");
  snprintf(face->amarok_temp_nowPlaying, 
		  sizeof(face->amarok_temp_nowPlaying),"%s", 
		  "/tmp/eloquence_amarok_nowPlaying.tmp");
  snprintf(face->amarok_com_isPlaying, 
		  sizeof(face->amarok_com_isPlaying), 
		  "dcop amarok player isPlaying > %s", 
		  face->amarok_temp_isPlaying);
  snprintf(face->amarok_com_nowPlaying, 
		  sizeof(face->amarok_com_nowPlaying), 
		  "dcop amarok player nowPlaying > %s", 
		  face->amarok_temp_nowPlaying);
}

int amarok_update_song(void *data){
  Eloquence_Face *face = data;
  char *file_playing;
  int running = 0;
  Ecore_Exe *x;
		 
  x = ecore_exe_run(face->amarok_com_isPlaying, face);
  if (x) ecore_exe_tag_set(x, "Amarok_isPlaying");
  if ((file_playing = fopen(face->amarok_temp_isPlaying, "r")) != NULL){
	  char playing[10];
	  fscanf(file_playing,"%s", playing);
	  if(!strcmp (playing, "true")){
		  char *file_song;
		  Ecore_Exe *x2;
		  x2 = ecore_exe_run(face->amarok_com_nowPlaying, face);
		  if (x2) ecore_exe_tag_set(x2, "Amarok_nowPlaying");
		  if ((file_song = fopen(face->amarok_temp_nowPlaying, "r")) != NULL){
			  fgets(face->outbuf, MAX_SONG_LENGTH, file_song);
			  face->song = face->outbuf;
			  fclose(file_song);
			  draw_text(face);
			  running = 1;
		  }
		  else{
			  fprintf(stderr, "Cannot open %s\n", face->amarok_temp_nowPlaying);
		  }
		  ecore_exe_free(x2);
	  }
	  fclose(file_playing);
  }
  else{
	  fprintf(stderr, "Cannot open %s\n", face->amarok_temp_isPlaying);
  }
  ecore_exe_free(x);

  return 1;
}

void amarok_control_play_pause(void *data){
  Eloquence_Face *face = data;
  char *input_file;
  
  ecore_exe_run(face->amarok_com_isPlaying, NULL);
  if ((input_file = fopen(face->amarok_temp_isPlaying, "r")) != NULL){
	  char playing[10];
	  fscanf(input_file,"%s", playing);
	  if(!strcmp (playing, "false"))
		  ecore_exe_run("dcop amarok player play", NULL);
	  else
		  ecore_exe_run("dcop amarok player pause", NULL);
	  fclose(input_file);
  }
  else{
	  fprintf(stderr, "Cannot open %s\n", face->amarok_temp_isPlaying);
  }
}

void amarok_control_track_next(void *data){
  ecore_exe_run("dcop amarok player next", NULL);
}

void amarok_control_track_prev(void *data){
  ecore_exe_run("dcop amarok player prev", NULL);
}

void amarok_control_vol_inc(void *data){
  ecore_exe_run("dcop amarok player volumeUp", NULL);
}

void amarok_control_vol_dec(void *data){
  ecore_exe_run("dcop amarok player volumeDown", NULL);
}

void amarok_control_shuffle(void *data){
	/* only enables shuffle, have to check if is enabled or disabled ;( */
  ecore_exe_run("dcop amarok player enableRandomMode 1", NULL);
}

void amarok_add_file_callback(void *data, Evas_Object *obj, const char *emission, const char *source){
  /* Empty now, for drag'n'drop of files to play */
}

#endif
