#include "e_mod_main.h"
#ifdef HAVE_AUDACIOUS_BEEPCTRL_H
#include <audacious/beepctrl.h>

int audacious_test_running(void *data);
int audacious_get_session(void *data);

int audacious_update_song(void *data){
  Eloquence_Face *face = data;
  
  int state = audacious_test_running(face);
  
  if(state == 1){
    gint pos = xmms_remote_get_playlist_pos(face->session.id);
    face->song = xmms_remote_get_playlist_file(face->session.id, pos);

    draw_text(face);
  }
  if(state == 2){
    face->song = "Audacious has been paused";
    draw_text(face);
  }
  if(state == 3){
    face->song = "";
    draw_text(face);
  }
  if((state == 4) && (face->session.id != -1)){
    face->song = "";
    draw_text(face);
    face->recheck_timer = ecore_timer_add(SEARCH_REFRESH, audacious_get_session, face);
    face->session.id = -1;
  }
  return 1;
}

int audacious_test_running(void *data){
  Eloquence_Face *face =  data;
  int state;

  if(xmms_remote_is_running(face->session.id)){
    if(xmms_remote_is_playing(face->session.id)){
      if(xmms_remote_is_paused(face->session.id)){
        return 2;
      }
      return 1;
    } 
    return 3;
  }
  return 4; 
}

int audacious_get_session(void *data){
  Eloquence_Face *face =  data;

  if(face->session.id == -1)
    ecore_timer_del(face->recheck_timer);
      
  for(face->session.id = 0 ; face->session.id < 16 ; face->session.id++){
     if(xmms_remote_is_running(face->session.id)){
       return 0;
     }        
  }
  if(face->session.id != -1){
    face->session.id = 0;
  }
  return 0;
}

void audacious_control_play_pause(void *data){
  Eloquence_Face *face =  data;

  if (xmms_remote_is_playing(face->session.id))
		  xmms_remote_pause(face->session.id);
  else
  		  xmms_remote_play(face->session.id);
		  
}

void audacious_control_track_next(void *data){
  Eloquence_Face *face =  data;
  xmms_remote_playlist_prev(face->session.id);
}

void audacious_control_track_prev(void *data){
  Eloquence_Face *face =  data;
  xmms_remote_playlist_next(face->session.id);
}

void audacious_control_vol_inc(void *data){
  Eloquence_Face *face =  data;
  int volume = xmms_remote_get_main_volume(face->session.id);  

  int pos = xmms_remote_get_playlist_pos(face->session.id);
  face->song = xmms_remote_get_playlist_title(face->session.id, pos);
  sprintf(face->outbuf, "%s   --   Volume: %i%%", face->song, volume);
  face->song = face->outbuf;
  draw_text(face);
  
  xmms_remote_set_main_volume(face->session.id, volume+2);
}

void audacious_control_vol_dec(void *data){
  Eloquence_Face *face =  data;
  int volume = xmms_remote_get_main_volume(face->session.id);

  int pos = xmms_remote_get_playlist_pos(face->session.id);
  face->song = xmms_remote_get_playlist_title(face->session.id, pos);
  sprintf(face->outbuf, "%s   --   Volume: %i%%", face->song, volume);
  face->song = face->outbuf;
  draw_text(face);
  
  xmms_remote_set_main_volume(face->session.id, volume-2);
}

void audacious_control_shuffle(void *data){
	  Eloquence_Face *face =  data;
	  xmms_remote_toggle_shuffle(face->session.id);
} 


void audacious_add_file_callback(void *data, Evas_Object *obj, const char *emission, const char *source){
  Eloquence_Face *face =  data;
  /* Empty now, for drag'n'drop of files to play */
}
#endif
