#include "e_mod_main.h"
#ifdef HAVE_BMPX_METADATA_H
#include <beep-media-player/bmpx/beepctrl.h>

int bmpx_test_running(void *data);
int bmpx_get_session(void *data);

int bmpx_update_song(void *data){
  Eloquence_Face *face = data;
  
  int state = bmpx_test_running(face);
  
  if(state == 1){
    gint pos = xmms_remote_get_playlist_pos(face->session);
    face->song = xmms_remote_get_playlist_file(face->session, pos);

/* some debugging fun */
//    sprintf(face->outbuf, "%s  (Track %i)", face->song, pos);
//    face->song = face->outbuf;

    draw_text(face);
  }
  if(state == 2){
    face->song = "Beep Media Player has been paused";
    draw_text(face);
  }
  if(state == 3){
    face->song = "";
    draw_text(face);
  }
  if((state == 4) && (face->session != -1)){
    face->song = "";
    draw_text(face);
    face->recheck_timer = ecore_timer_add(SEARCH_REFRESH, bmpx_get_session, face);
    face->session = -1;
  }
  return 1;
}

int bmpx_test_running(void *data){
  Eloquence_Face *face =  data;
  int state;

  if(xmms_remote_is_running(face->session)){
    if(xmms_remote_is_playing(face->session)){
      if(xmms_remote_is_paused(face->session)){
        return 2;
      }
      return 1;
    } 
    return 3;
  }
  return 4; 
}

int bmpx_get_session(void *data){
  Eloquence_Face *face =  data;

  if(face->session == -1)
    ecore_timer_del(face->recheck_timer);
      
  for(face->session = 0 ; face->session < 16 ; face->session++){
     if(xmms_remote_is_running(face->session)){
       return 0;
     }        
  }
  if(face->session != -1){
    face->session = 0;
  }
  return 0;
}

void bmpx_control_play_pause(void *data){
  Eloquence_Face *face =  data;

  if (xmms_remote_is_playing(face->session))
		  xmms_remote_pause(face->session);
  else
  		  xmms_remote_play(face->session);
		  
}

void bmpx_control_track_next(void *data){
  Eloquence_Face *face =  data;
  xmms_remote_playlist_prev(face->session);
}

void bmpx_control_track_prev(void *data){
  Eloquence_Face *face =  data;
  xmms_remote_playlist_next(face->session);
}

void bmpx_control_vol_inc(void *data){
  Eloquence_Face *face =  data;
  int volume = xmms_remote_get_main_volume(face->session);  

  int pos = xmms_remote_get_playlist_pos(face->session);
  face->song = xmms_remote_get_playlist_title(face->session, pos);
  sprintf(face->outbuf, "%s   --   Volume: %i%%", face->song, volume);
  face->song = face->outbuf;
  draw_text(face);
  
  xmms_remote_set_main_volume(face->session, volume+2);
}

void bmpx_control_vol_dec(void *data){
  Eloquence_Face *face =  data;
  int volume = xmms_remote_get_main_volume(face->session);

  int pos = xmms_remote_get_playlist_pos(face->session);
  face->song = xmms_remote_get_playlist_title(face->session, pos);
  sprintf(face->outbuf, "%s   --   Volume: %i%%", face->song, volume);
  face->song = face->outbuf;
  draw_text(face);
  
  xmms_remote_set_main_volume(face->session, volume-2);
}

void bmpx_control_shuffle(void *data){
	  Eloquence_Face *face =  data;
	  xmms_remote_toggle_shuffle(face->session);
} 


void bmpx_add_file_callback(void *data, Evas_Object *obj, const char *emission, const char *source){
  Eloquence_Face *face =  data;
  /* Empty now, for drag'n'drop of files to play */
}
#endif
